package cn.superdesk.uniorder.dubbo.consumer.operationCenter.customer;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param.operationCenter.customer.settlement.UnifiedSettlementParam;
import cn.superdesk.uniorder.dubbo.facade.unified.settlement.DubboUnifiedSettlementProgrammeService;
import com.alibaba.dubbo.config.annotation.Reference;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * @Author : zx
 * @Create : 2023/5/10 16:29
 * Description :
 */
@Slf4j
@Component
public class UnifiedSettlementDubboService {
    @Reference(version = "1.0.0", timeout = 30000, retries = -1)
    private DubboUnifiedSettlementProgrammeService dubboUnifiedSettlementProgrammeService;


    public R<String> saveUnifiedSettlement(UnifiedSettlementParam param, String token) {
        LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
        return dubboUnifiedSettlementProgrammeService.saveUnifiedSettlement(param, loginSysUser.getSysUserId());
    }
}
